:- load_library('alice.tucson.api.Tucson2PLibrary').
:- solve(go).

go :-
	enter_default_context,

	text_from_file('prolog/vuoto.rsp',SV),
	semaforo ? set_spec(SV),
	rotonda ? set_spec(SV),

	semaforo ? out(stato(stop)),
	semaforo ? out(luce_verde(nord)),
	semaforo ? out(spazio(incrocio)),

	semaforo ? out(coda(nord,0)),
	semaforo ? out(coda(sud,0)),
	semaforo ? out(coda(ovest,0)),
	semaforo ? out(coda(est,0)),

	semaforo ? out(avanti(nord,0)),
	semaforo ? out(avanti(sud,0)),
	semaforo ? out(avanti(ovest,0)),
	semaforo ? out(avanti(est,0)),

	semaforo ? out(utenti(nord,0)),
	semaforo ? out(utenti(sud,0)),
	semaforo ? out(utenti(ovest,0)),
	semaforo ? out(utenti(est,0)),
	semaforo ? out(utenti(totale,0)),

	semaforo ? out(statistiche(utenti_serviti,0)),
	semaforo ? out(statistiche(utenti_arrivati,0)),
 	semaforo ? out(statistiche(tempo_servizio,0)),
	semaforo ? out(statistiche(tempo_arrivo,0)),
	semaforo ? out(statistiche(coda_max,0)),
 	
	text_from_file('prolog/semaforo.rsp',SS),
	semaforo ? set_spec(SS),
	

	rotonda ? out(stato(stop)),

	rotonda ? out(coda(nord,0)),
	rotonda ? out(coda(sud,0)),
	rotonda ? out(coda(ovest,0)),
	rotonda ? out(coda(est,0)),

	rotonda ? out(avanti(nord,0)),
	rotonda ? out(avanti(sud,0)),
	rotonda ? out(avanti(ovest,0)),
	rotonda ? out(avanti(est,0)),

	rotonda ? out(utenti(nord,0)),
	rotonda ? out(utenti(sud,0)),
	rotonda ? out(utenti(ovest,0)),
	rotonda ? out(utenti(est,0)),
	rotonda ? out(utenti(totale,0)),
	
	rotonda ? out(statistiche(utenti_serviti,0)),
	rotonda ? out(statistiche(tempo_servizio,0)),
	rotonda ? out(statistiche(coda_max,0)),

	text_from_file('prolog/rotonda.rsp',SR),
	rotonda ? set_spec(SR),

	rotonda ? out(spazio(nord,ovest)),
	rotonda ? out(spazio(ovest,sud)),
	rotonda ? out(spazio(sud,est)),
	rotonda ? out(spazio(est,nord)),
	
	semaforo ? out(setup(ok)),

	exit_context.